/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

USEFORM("Main.cpp", MainForm);
USEFORM("Contact.cpp", ContactForm);
USEFORM("Talk.cpp", TalkForm);
USEFORM("Settings.cpp", SettingsForm);
USEFORM("Search.cpp", SearchForm);
USEFORM("SMS.cpp", SMSForm);
USEFORM("Token.cpp", TokenForm);
USEFORM("NewAccnt.cpp", NewAccntForm);
USEFORM("DelAccnt.cpp", DelAccntForm);
USEFORM("ChPwd.cpp", ChPwdForm);
USEFORM("RemindPwd.cpp", RemindPwdForm);
USEFORM("StatusDesc.cpp", StatusDescForm);
USEFORM("History.cpp", HistoryForm);
USEFORM("Me.cpp", MeForm);
USEFORM("Activity.cpp", ActivityForm);
USEFORM("Popup.cpp", MyPopupForm);
USEFORM("SMSConfig.cpp", SMSConfigForm);
USEFORM("GGToken.cpp", GGTokenForm);
//---------------------------------------------------------------------------
#include "GaduThread.h"
#include "Settings.h"
#include "Main.h"

#include <shlobj.h>

TGaduThread *gg_thread;
AnsiString GGDir;
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR cmdline, int)
{
	try
	{
		/** \todo Jaki prawdziwy parser linii komend jeeli kiedy przybdzie
		parametrw */
		if(strstr(cmdline, "noprofiles"))
		{
			GGDir = ExtractFileDir(Application->ExeName);
		}
		else
		{
			char buf[MAX_PATH] = {0};
			SHGetFolderPath (NULL, CSIDL_PROFILE, NULL, SHGFP_TYPE_CURRENT, buf);
			GGDir = (AnsiString)buf + "\\Free GG";
		}
		if (!DirectoryExists (GGDir)) CreateDir (GGDir);
		if (!DirectoryExists (GGDir + "\\logs")) CreateDir (GGDir + "\\logs");
		if (!DirectoryExists (GGDir + "\\sms")) CreateDir (GGDir + "\\sms");
		if (!DirectoryExists (GGDir + "\\temp")) CreateDir (GGDir + "\\temp");

		Application->Initialize();
		Application -> ShowMainForm = false;
		Application->CreateForm(__classid(TMainForm), &MainForm);
		Application->CreateForm(__classid(TContactForm), &ContactForm);
		Application->CreateForm(__classid(TTalkForm), &TalkForm);
		Application->CreateForm(__classid(TActivityForm), &ActivityForm);
		Application->CreateForm(__classid(TSettingsForm), &SettingsForm);
		Application->CreateForm(__classid(TSearchForm), &SearchForm);
		Application->CreateForm(__classid(TSMSForm), &SMSForm);
		Application->CreateForm(__classid(TTokenForm), &TokenForm);
		Application->CreateForm(__classid(TStatusDescForm), &StatusDescForm);
		Application->CreateForm(__classid(TMeForm), &MeForm);
		Application->CreateForm(__classid(TMyPopupForm), &MyPopupForm);
		Application->CreateForm(__classid(TSMSConfigForm), &SMSConfigForm);
		Application->CreateForm(__classid(TGGTokenForm), &GGTokenForm);
		if (SettingsForm -> ListView1 -> Items -> Item[5] -> SubItems -> Strings[0] != "0") MainForm -> Left = StrToInt (SettingsForm -> ListView1 -> Items -> Item[5] -> SubItems -> Strings[0]);
		if (SettingsForm -> ListView1 -> Items -> Item[6] -> SubItems -> Strings[0] != "0") MainForm -> Top = StrToInt (SettingsForm -> ListView1 -> Items -> Item[6] -> SubItems -> Strings[0]);
		if (SettingsForm -> ListView1 -> Items -> Item[7] -> SubItems -> Strings[0] != "0") MainForm -> Width = StrToInt (SettingsForm -> ListView1 -> Items -> Item[7] -> SubItems -> Strings[0]);
		if (SettingsForm -> ListView1 -> Items -> Item[8] -> SubItems -> Strings[0] != "0") MainForm -> Height = StrToInt (SettingsForm -> ListView1 -> Items -> Item[8] -> SubItems -> Strings[0]);
		SetWindowLong (MainForm -> Handle, GWL_EXSTYLE, GetWindowLong (MainForm -> Handle, GWL_EXSTYLE) | WS_EX_LAYERED);
		::SetLayeredWindowAttributes (MainForm -> Handle, 0, 255 - StrToInt(SettingsForm -> ListView1 -> Items -> Item[10] -> SubItems -> Strings[0]), LWA_ALPHA);

		if (SettingsForm -> ListView1 -> Items -> Item[12] -> SubItems -> Strings[0] == "0") MainForm -> Show();

		gg_thread = new TGaduThread (true);
		gg_thread -> Resume();

		TMenuItem *I = gg_thread -> StatusToMenuItem(StrToInt (SettingsForm -> ListView1 -> Items -> Item[2] -> SubItems -> Strings[0]));
		if (I != NULL)
		{
			I -> Checked = true;
			MainForm -> TrayIcon1 -> IconIndex = I -> ImageIndex;
		}
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	return 0;
}
//---------------------------------------------------------------------------
