/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GGToken.h"
#include <stdio.h>
#include <jpeg.hpp>
#include <ScktComp.hpp>
#include "winimage/winimage.h"	///< modified library written by Juan Soulie

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGGTokenForm *GGTokenForm;
static C_Image img;
static C_ImageSet imgset;
static C_AnimationWindow anim;

//---------------------------------------------------------------------------
__fastcall TGGTokenForm::TGGTokenForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
extern AnsiString GGDir;
//---------------------------------------------------------------------------
void TokenProc (AnsiString &asTokenId)
{
        TClientSocket *S;
        TWinSocketStream *SS;
        AnsiString Request, Reply;
        int read;
        char buf [256];

        S = new TClientSocket (NULL);
        S -> ClientType = ctBlocking;
        S -> Port = 80;
        S -> Host = "register.gadu-gadu.pl";
        S -> Open();

        SS = new TWinSocketStream (S -> Socket, 10000);

		Request = "POST /appsvc/regtoken.asp HTTP/1.0\r\n\
Host: register.gadu-gadu.pl\r\n\
Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/vnd.ms-powerpoint, application/vnd.ms-excel, application/msword, application/x-shockwave-flash, */*\r\n\
Accept-Language: pl\r\n\
Content-Type: application/x-www-form-urlencoded\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows NT; DigExt)\r\n\
Content-Length: 0\r\n\
Pragma: no-cache\r\n\r\n\
";	///< cig zapoyczony z gg 6.0 b. 147


        SS -> Write (Request.c_str(), Request.Length());

		while ( (read = SS -> Read (buf, sizeof(buf))) > 0 )
        {
                Reply += ((AnsiString)buf).SubString (1, read);
        }

        int pos;
        AnsiString cookie;
		const char STR_FIND_START[] = "Connection: close\r\n\r\n";	//pocztek interesujcych info
		pos = Reply.Pos (STR_FIND_START);
		AnsiString id = Reply.SubString (pos + strlen(STR_FIND_START), Reply.Length() - pos - strlen(STR_FIND_START) + 1);
		AnsiString asTokenParams = id.SubString (1, id.Pos ("\r\n") - 1);	// "width height chars_count"
		asTokenId = id.SubString(id.Pos("\r\n") + 2, id.Pos("\r\nhttp") - (id.Pos("\r\n") + 2));
		AnsiString asTokenUrl = id.SubString(id.Pos("http"), id.Length() - id.Pos("http") + 1);

		//wydobd nazw hosta i ciek do skryptu z url-a
		/** \todo mona byoby zrobi to porzdniej */
		AnsiString asHost = asTokenUrl.SubString(1, asTokenUrl.Pos(".pl/") + 2 );
		if(asHost.Pos("http://"))
			asHost = asHost.SubString(asHost.Pos("http://") + 7, asHost.Length() - 7);
		AnsiString asPath = asTokenUrl.SubString(asTokenUrl.Pos(".pl/") + 3, asTokenUrl.Length() - asTokenUrl.Pos(".pl/") + 3);
        delete SS;
        S -> Close();
        delete S;

        S = new TClientSocket (NULL);
        S -> ClientType = ctBlocking;
		S -> Port = 80;
		S -> Host = asHost;
        S -> Open();

        SS = new TWinSocketStream (S -> Socket, 10000);

		Request = "GET " + asPath + "?tokenid=" + asTokenId + " HTTP/1.0\r\n\
Accept: */*\r\n\
Accept-Language: pl\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322)\r\n\
Host: " + asHost + "\r\n\
Connection: Keep-Alive\r\n\r\n";


        SS -> Write (Request.c_str(), Request.Length());

        char *big_buf = NULL;
        int big_buf_size = 0;

        while ((read = SS -> Read (buf, sizeof(buf))) > 0)
        {
                big_buf_size += read;
                if (big_buf_size > 65535) break;
                big_buf = (char*)realloc (big_buf, big_buf_size);
                memcpy (big_buf + big_buf_size - read, buf, read);
        }

        pos = ((AnsiString)big_buf).Pos ("\r\n\r\n");

        delete SS;
		S -> Close();
		delete S;
		/** \todo fajnie byoby sprawdza jakiego typu jest token */
 #define JPEG_TOKEN 0
 #if JPEG_TOKEN
		FILE *f = fopen ((GGDir + "\\temp\\gg_token_pic.jpg").c_str(), "wb");
		fwrite (big_buf + pos + 3, 1, big_buf_size - pos - 3, f);
		fclose (f);
		free (big_buf);

		TJPEGImage *jpg = new TJPEGImage;
		jpg -> LoadFromFile (GGDir + "\\temp\\gg_token_pic.jpg");
		GGTokenForm -> Image1 -> Picture -> Assign (jpg);
		delete jpg;

 #else	//GIF token
		for (int n=0;n<imgset.nImages;n++)
		{
			delete imgset.img[n];
			imgset.img[n] = NULL;
		}
		delete [] imgset.img;
		imgset.img = NULL;
		imgset.nImages = 0;


		FILE *f = fopen ((GGDir + "\\temp\\gg_token_pic.gif").c_str(), "wb");
		fwrite (big_buf + pos + 3, 1, big_buf_size - pos - 3, f);
		fclose (f);
		free (big_buf);
		// Load Image files
		imgset.LoadGIF ((GGDir + "\\temp\\gg_token_pic.gif").c_str());
		anim.Create (GGTokenForm->Handle,(HMENU)1000,&imgset);

		anim.Display (10,10);
 #endif
 
}
//---------------------------------------------------------------------------


void __fastcall TGGTokenForm::FormPaint(TObject *Sender)
{
        // odwieenie wywietlanego gif-a
		// Paint the img object (BMP file):
		HDC hdc;
		PAINTSTRUCT ps;
		hdc=BeginPaint (this->Handle,&ps);
		img.GDIPaint (hdc,10,10);
		EndPaint (this->Handle,&ps);
}
//---------------------------------------------------------------------------


